 /*
 * Copyright (C) 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
*/

#pragma once
#include "afxwin.h"


class CCalendarSettings : public CDialog
{
	DECLARE_DYNCREATE(CCalendarSettings)

public:
	CCalendarSettings();           
	virtual ~CCalendarSettings();

	enum { IDD = IDD_CALENDAR };
#ifdef _DEBUG
	virtual void AssertValid() const;
#ifndef _WIN32_WCE
	virtual void Dump(CDumpContext& dc) const;
#endif
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    virtual BOOL OnInitDialog();

	DECLARE_MESSAGE_MAP()
public:
    CComboBox lstSyncType; // sync types
    CEdit editFolder;     // folder to sync
    CButton checkIncludeSubfolders; // include subfolders
    CButton butSelectFolder;    // button for selecting the folder to be synced
    CEdit editRemote; // remote name of the source
    CButton radioSif;
    CButton radioVcard;
    CButton butAdvanced;
    CStatic groupDirection;
    CStatic groupFolder;
    CStatic groupAdvanced;

    bool saveSettings(bool saveToDisk);

    afx_msg void OnBnClickedCalendarButok();
    afx_msg void OnBnClickedCalendarButcancel();
    afx_msg void OnBnClickedCalendarButSelect();
};


