 /*
 * Copyright (C) 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
*/


#if !defined(AFX_MAINFRM_H__FA98B70F_D0B7_11D3_BC39_00C04F602FEE1__INCLUDED_)
#define AFX_MAINFRM_H__FA98B70F_D0B7_11D3_BC39_00C04F602FEE1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "HwndFunctions.h"
#include "ConfigFrm.h"

class CMainSyncFrame : public CFrameWnd
{

private:
    // Counters, incremented each time a source has begun.
    // (1 when begin sending data, 2 when begin receiving data)
    int contactsBegin;
    int calendarBegin;
    int tasksBegin;
    int notesBegin;
	
protected: // create from serialization only
  CMainSyncFrame();
  DECLARE_DYNCREATE(CMainSyncFrame)

public:
    CConfigFrame* pConfigFrame;

    // bitmaps, load once, use it everywhere
    HBITMAP hBmpDarkBlue;
    HBITMAP hBmpBlue;
    HBITMAP hBmpDark;
    HBITMAP hBmpLight;

protected:
    HANDLE hSyncThread;
    DWORD dwThreadId;
    bool configOpened;
    int dpiX, dpiY;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CConfigFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainSyncFrame();
    void backupSyncModeSettings();
    void restoreSyncModeSettings();
    void showSettingsWindow(const int paneToDisplay = 1);
    
    // check if the user has set the connection settings
    bool checkConnectionSettings(); 

    int getDpiX() {return dpiX;}
    int getDpiY() {return dpiY;}
  
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected: 
    // info about sync modes for sources, used on full sync
    int syncModeCalendar; 
    int syncModeContacts;
    int syncModeTasks;
    int syncModeNotes;

    // info about the sync in progress
    int currentSource;
    int totalItems;
    int currentItem;
    
    CFont fontBold;
    
public:
    CStatusBar wndStatusBar;
    CSplitter wndSplitter;
    bool bSyncStarted;

    void OnConfigClosed();
    void StartSync();
    int CancelSync();

// Generated message map functions
protected:
	//{{AFX_MSG(CConfigFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
    //afx_msg void OnUpdatePage(CCmdUI *pCmdUI); //status bar update
    afx_msg LRESULT OnMsgSyncBegin(WPARAM , LPARAM);
    afx_msg LRESULT OnMsgSyncEnd(WPARAM , LPARAM);
    afx_msg LRESULT OnMsgSyncSourceBegin(WPARAM , LPARAM);
    afx_msg LRESULT OnMsgSyncSourceEnd(WPARAM , LPARAM);
    afx_msg LRESULT OnMsgItemSynced(WPARAM , LPARAM);
    afx_msg LRESULT OnMsgTotalItems(WPARAM , LPARAM); 
    afx_msg LRESULT OnMsgStartSyncBegin(WPARAM , LPARAM); 
    afx_msg LRESULT OnMsgStartsyncEnded(WPARAM , LPARAM); 
    afx_msg LRESULT OnMsgRefreshStatusBar(WPARAM, LPARAM);
    afx_msg LRESULT OnMsgAppModal(WPARAM, LPARAM);
    afx_msg LRESULT OnMsgSyncSourceState(WPARAM, LPARAM);
    afx_msg LRESULT OnMsgUnlockButtons(WPARAM, LPARAM);

    afx_msg void OnFileConfiguration();
    afx_msg void OnToolsFullSync();
    afx_msg void OnFileSynchronize();
    afx_msg int  OnCancelSync();
    afx_msg void OnToolsSetloglevel();

    afx_msg BOOL OnNcActivate(BOOL bActive);
    afx_msg void OnClose();
};

// Thread related
DWORD WINAPI syncThread(LPVOID lpParam);
DWORD WINAPI syncThreadKiller(LPVOID lpParam);

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__FA98B70F_D0B7_11D3_BC39_00C04F602FEE__INCLUDED_)
