 /*
 * Copyright (C) 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
*/

// SyncSettings.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "SyncSettings.h"
#include "MainSyncFrm.h"
#include "ClientUtil.h"

#include "LeftView.h"
#include "ContactSettings.h"
#include "CalendarSettings.h"
#include "NotesSettings.h"
#include "TaskSettings.h"

#include "winmaincpp.h"
#include "utils.h"
#include "OutlookPlugin.h"

// CSyncSettings

IMPLEMENT_DYNCREATE(CSyncSettings, CFormView)

CSyncSettings::CSyncSettings()
	: CFormView(CSyncSettings::IDD)
{

}

CSyncSettings::~CSyncSettings()
{
}

void CSyncSettings::DoDataExchange(CDataExchange* pDX)
{
    CFormView::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_SYNC_CHECK_CONTACTS, checkContacts);
    DDX_Control(pDX, IDC_SYNC_CHECK_CALENDAR, checkCalendar);
    DDX_Control(pDX, IDC_SYNC_CHECK_TASKS, checkTasks);
    DDX_Control(pDX, IDC_SYNC_CHECK_NOTES, checkNotes);
    DDX_Control(pDX, IDC_SYNC_BUT_CONTACTS, butContacts);
    DDX_Control(pDX, IDC_SYNC_BUT_CALENDAR, butCalendar);
    DDX_Control(pDX, IDC_SYNC_BUT_TASKS, butTasks);
    DDX_Control(pDX, IDC_SYNC_BUT_NOTES, butNotes);

    DDX_Control(pDX, IDC_SCHEDULER_CHECK_ENABLED, checkEnabled);
    DDX_Control(pDX, IDC_SCHEDULER_VALUE, lstValue);
    DDX_Control(pDX, IDC_SCHEDULER_SPIN, spinValue);
    DDX_Control(pDX, IDC_SCHEDULER_COMBO_VALUE_TYPE, comboValueType);
    DDX_Control(pDX, IDC_SYNC_CHECK_ENCRYPTION, checkEncryption);
    DDX_Control(pDX, IDC_SYNC_GROUP_ITEMS, groupItems);
    DDX_Control(pDX, IDC_SCHEDULER_GROUP, groupScheduler);
    DDX_Control(pDX, IDC_SYNC_GROUP_SECURITY, groupSecurity);
}

BEGIN_MESSAGE_MAP(CSyncSettings, CFormView)
    ON_MESSAGE( WM_INITDIALOG, OnInitForm ) 
    ON_BN_CLICKED(IDC_SYNC_CHECK_CONTACTS, &CSyncSettings::OnBnClickedSyncCheckContacts)
    ON_BN_CLICKED(IDC_SYNC_CHECK_CALENDAR, &CSyncSettings::OnBnClickedSyncCheckCalendar)
    ON_BN_CLICKED(IDC_SYNC_CHECK_TASKS, &CSyncSettings::OnBnClickedSyncCheckTasks)
    ON_BN_CLICKED(IDC_SYNC_CHECK_NOTES, &CSyncSettings::OnBnClickedSyncCheckNotes)
    ON_BN_CLICKED(IDC_SYNC_OK, &CSyncSettings::OnBnClickedSyncOk)
    ON_BN_CLICKED(IDC_SYNC_CANCEL, &CSyncSettings::OnBnClickedSyncCancel)
    ON_BN_CLICKED(IDC_SYNC_BUT_CONTACTS, &CSyncSettings::OnBnClickedSyncButContacts)
    ON_BN_CLICKED(IDC_SYNC_BUT_CALENDAR, &CSyncSettings::OnBnClickedSyncButCalendar)
    ON_BN_CLICKED(IDC_SYNC_BUT_TASKS, &CSyncSettings::OnBnClickedSyncButTasks)
    ON_BN_CLICKED(IDC_SYNC_BUT_NOTES, &CSyncSettings::OnBnClickedSyncButNotes)
    ON_WM_NCPAINT()
    ON_BN_CLICKED(IDC_SCHEDULER_CHECK_ENABLED, &CSyncSettings::OnBnClickedSchedulerCheckEnabled)
    ON_CBN_SELCHANGE(IDC_SCHEDULER_COMBO_VALUE_TYPE, &CSyncSettings::OnCbnSelchangeSchedulerComboValueType)
    ON_EN_CHANGE(IDC_SCHEDULER_VALUE, &CSyncSettings::OnEnChangeSchedulerValue)
END_MESSAGE_MAP()


// CSyncSettings diagnostics

#ifdef _DEBUG
void CSyncSettings::AssertValid() const
{
	CFormView::AssertValid();
}

#ifndef _WIN32_WCE
void CSyncSettings::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif
#endif //_DEBUG


// CSyncSettings message handlers
LRESULT CSyncSettings::OnInitForm(WPARAM, LPARAM){
    CFormView::OnInitialUpdate();
    CString s1;
    int minutes = 0;
    
    s1.LoadString(IDS_ITEMS); SetDlgItemText(IDC_SYNC_GROUP_ITEMS,s1);
    s1.LoadString(IDS_SCHEDULER); SetDlgItemText(IDC_SCHEDULER_GROUP,s1);
    s1.LoadString(IDS_CONTACTS); SetDlgItemText(IDC_SYNC_STATIC_CONTACTS,s1);
    s1.LoadString(IDS_CALENDAR); SetDlgItemText(IDC_SYNC_STATIC_CALENDAR,s1);
    s1.LoadString(IDS_TASKS); SetDlgItemText(IDC_SYNC_STATIC_TASKS,s1);
    s1.LoadString(IDS_NOTES); SetDlgItemText(IDC_SYNC_STATIC_NOTES,s1);
    
    s1.LoadString(IDS_DETAILS);  
    SetDlgItemText(IDC_SYNC_BUT_CONTACTS,s1); SetDlgItemText(IDC_SYNC_BUT_CALENDAR,s1);
    SetDlgItemText(IDC_SYNC_BUT_NOTES,s1); SetDlgItemText(IDC_SYNC_BUT_TASKS,s1);

    s1.LoadString(IDS_CONTACTS); SetDlgItemText(IDC_SYNC_CHECK_CONTACTS, s1);
    s1.LoadString(IDS_CALENDAR); SetDlgItemText(IDC_SYNC_CHECK_CALENDAR, s1);
    s1.LoadString(IDS_TASKS); SetDlgItemText(IDC_SYNC_CHECK_TASKS, s1);
    s1.LoadString(IDS_NOTES); SetDlgItemText(IDC_SYNC_CHECK_NOTES, s1);

    s1.LoadString(IDS_OK); SetDlgItemText(IDC_SYNC_OK, s1);
    s1.LoadString(IDS_CANCEL); SetDlgItemText(IDC_SYNC_CANCEL, s1);

    // scheduler
    s1.LoadString(IDS_SYNC_SYNCHRONIZE_EVERY); SetDlgItemText(IDC_SCHEDULER_CHECK_ENABLED,s1);
    spinValue.SetBuddy(&lstValue); 
    spinValue.SetRange(SCHEDULER_MIN_MINUTES, SCHEDULER_MAX_MINUTES); 
    lstValue.SetLimitText(EDIT_TEXT_SCHEDULER_MAXLENGTH); // numbers with max 6 digits are accepted
    s1.LoadString(IDS_MINUTES); comboValueType.AddString(s1);
    s1.LoadString(IDS_HOURS);   comboValueType.AddString(s1); 

    s1.LoadString(IDS_SECURITY);   SetDlgItemText(IDC_SYNC_GROUP_SECURITY, s1);
    s1.LoadString(IDS_SYNC_ENABLE_ENCRYPTION);   SetDlgItemText(IDC_SYNC_CHECK_ENCRYPTION, s1);

    // enable/disable controls, depending of what sources are set to none
    WindowsSyncSourceConfig* ssc = getConfig()->getSyncSourceConfig(CONTACT_);
    if(! strcmp(ssc->getSync(),"none")){
        checkContacts.SetCheck(BST_UNCHECKED);
        butContacts.EnableWindow(FALSE);
    }
    else{
        checkContacts.SetCheck(BST_CHECKED);
    }

    ssc = getConfig()->getSyncSourceConfig(APPOINTMENT_);
    if(! strcmp(ssc->getSync(),"none")){
        checkCalendar.SetCheck(BST_UNCHECKED);
        butCalendar.EnableWindow(FALSE);
    }
    else{
        checkCalendar.SetCheck(BST_CHECKED);
    }

    ssc = getConfig()->getSyncSourceConfig(TASK_);
    if(! strcmp(ssc->getSync(),"none")){
        checkTasks.SetCheck(BST_UNCHECKED);
        butTasks.EnableWindow(FALSE);
    }
    else{
        checkTasks.SetCheck(BST_CHECKED);
    }

    ssc = getConfig()->getSyncSourceConfig(NOTE_);
    if(! strcmp(ssc->getSync(),"none")){
        checkNotes.SetCheck(BST_UNCHECKED);
        butNotes.EnableWindow(FALSE);
    }
    else{
        checkNotes.SetCheck(BST_CHECKED);
    }

    
    // load scheduler settings
    if(! getScheduler(&minutes)){
        checkEnabled.SetCheck(BST_UNCHECKED);
        lstValue.EnableWindow(FALSE);
        spinValue.EnableWindow(FALSE);
        comboValueType.EnableWindow(FALSE);
        comboValueType.SetCurSel(0);
    }
    else{
        checkEnabled.SetCheck(BST_CHECKED);
        lstValue.EnableWindow(TRUE);
        spinValue.EnableWindow(TRUE);
        comboValueType.EnableWindow(TRUE);

        if(minutes % 60 == 0){
            // hours
            s1 = "";
            char* temp = ltow(minutes / 60);
            s1 += temp;
            delete [] temp; temp = NULL;
            SetDlgItemText(IDC_SCHEDULER_VALUE, s1);
            comboValueType.SetCurSel(1);
        }
        else{
            // minutes
            s1 = "";
            char* temp = ltow(minutes);
            s1 += temp;
            delete [] temp; temp = NULL;

            SetDlgItemText(IDC_SCHEDULER_VALUE, s1);
            comboValueType.SetCurSel(0);
        }
    }

    // encryption is global
    if( (strcmp(getConfig()->getSyncSourceConfig(CONTACT_)->getEncryption(),"") != 0) ||
        (strcmp(getConfig()->getSyncSourceConfig(APPOINTMENT_)->getEncryption(),"") != 0) ||
        (strcmp(getConfig()->getSyncSourceConfig(TASK_)->getEncryption(),"") != 0) ||
        (strcmp(getConfig()->getSyncSourceConfig(NOTE_)->getEncryption(),"") != 0) )
        checkEncryption.SetCheck(BST_CHECKED);
    else
        checkEncryption.SetCheck(BST_UNCHECKED);

    // Portal build: disable notes and encryption
    if(getConfig()->checkPortalBuild()) {
        checkNotes.EnableWindow(FALSE);
        butNotes.EnableWindow(FALSE);
        saveSyncTypeNotes = false;

        checkEncryption.SetCheck(BST_UNCHECKED);
        checkEncryption.EnableWindow(FALSE);
    }
    else{
        saveSyncTypeNotes = true;
    }

    saveSyncTypeContacts = true;    
    saveSyncTypeCalendar = true;
    saveSyncTypeTasks = true;

    saveScheduler = false;

    // disable windows xp theme, otherwise any color setting for groupbox
    // will be overriden by the theme settings
    if(((COutlookPluginApp*)AfxGetApp())->hLib){
        PFNSETWINDOWTHEME pfnSetWindowTheme =
            (PFNSETWINDOWTHEME)GetProcAddress(((COutlookPluginApp*)AfxGetApp())->hLib, "SetWindowTheme");
        pfnSetWindowTheme (groupItems.m_hWnd,L" ",L" ");
        pfnSetWindowTheme (groupScheduler.m_hWnd,L" ",L" ");
        pfnSetWindowTheme (groupSecurity.m_hWnd,L" ",L" ");
    };

    return 0;
}

void CSyncSettings::OnBnClickedSyncCheckContacts()
{
    if(checkContacts.GetCheck() == BST_UNCHECKED){
        butContacts.EnableWindow(FALSE);
    }
    else{
        butContacts.EnableWindow(TRUE);
    }

    saveSyncTypeContacts = true;
}

void CSyncSettings::OnBnClickedSyncCheckCalendar()
{
    if(checkCalendar.GetCheck() == BST_UNCHECKED){
        butCalendar.EnableWindow(FALSE);
    }
    else{
        butCalendar.EnableWindow(TRUE);
    }
    saveSyncTypeCalendar = true;
}

void CSyncSettings::OnBnClickedSyncCheckTasks()
{
    if(checkTasks.GetCheck() == BST_UNCHECKED){
        butTasks.EnableWindow(FALSE);
    }
    else{
        butTasks.EnableWindow(TRUE);
    };
    saveSyncTypeTasks = true;
}

void CSyncSettings::OnBnClickedSyncCheckNotes()
{
    if(checkNotes.GetCheck() == BST_UNCHECKED)
        butNotes.EnableWindow(FALSE);
    else
        butNotes.EnableWindow(TRUE);

    saveSyncTypeNotes = true;
}

void CSyncSettings::OnBnClickedSyncOk()
{
    // OK Button
    if(saveSettings(true)){
        ((CMainSyncFrame*)AfxGetMainWnd())->pConfigFrame->DoCancel();
    }
}

void CSyncSettings::OnBnClickedSyncCancel()
{
    // CANCEL button
    getConfig()->read();
    ((CMainSyncFrame*)AfxGetMainWnd())->pConfigFrame->DoCancel();
}

void CSyncSettings::OnBnClickedSyncButContacts()
{
    CContactSettings wndContacts;
    INT_PTR result = wndContacts.DoModal();
    saveSyncTypeContacts = (result != IDOK);
}

void CSyncSettings::OnBnClickedSyncButCalendar()
{
    CCalendarSettings wndCalendar;
    INT_PTR result = wndCalendar.DoModal();
    saveSyncTypeCalendar = (result != IDOK);
}

void CSyncSettings::OnBnClickedSyncButTasks()
{
    CTaskSettings wndTasks;
    INT_PTR result = wndTasks.DoModal();
    saveSyncTypeTasks = (result != IDOK);
}

void CSyncSettings::OnBnClickedSyncButNotes()
{
    CNotesSettings wndNotes;
    INT_PTR result = wndNotes.DoModal();
    saveSyncTypeNotes = (result != IDOK);
}


bool CSyncSettings::saveSettings(bool saveToDisk)
{    
    CString s1,s2,msg;
    _bstr_t bst;
    int minutes=0, hours=0;

    // if scheduler values haven't changed, do not save it again
    if(saveScheduler){
    // check scheduler values
    if(checkEnabled.GetCheck() == BST_UNCHECKED){
        setScheduler(false, 0); 
        //return true; // return ok
    }
    else{
        // scheduler enabled
        GetDlgItemText(IDC_SCHEDULER_VALUE, s1);
        if(s1 == ""){
            msg.LoadString(IDS_SCHEDULER_PLEASE_SET_VALUE);
            MessageBox(msg);
            return false;
        };

        if(comboValueType.GetCurSel() == 0){
            // minutes
            bst.Assign(s1.AllocSysString());
            minutes = atoi(bst); bst.Detach();
            if(minutes < SCHEDULER_MIN_MINUTES){
                msg.LoadString(IDS_SCHEDULER_MIN_VALUE_IS);
                msg+=" ";   msg += SCHEDULER_MIN_MINUTES_WIDE;
                MessageBox(msg);
                return false;
            };

            if(minutes > SCHEDULER_MAX_MINUTES){
                msg.LoadString(IDS_SCHEDULER_MAX_VALUE_IS);
                msg+=" ";   msg += SCHEDULER_MAX_MINUTES_WIDE;
                MessageBox(msg);
                return false;
            };
         }
        else{
            // hours
            bst.Assign(s1.AllocSysString());
            hours = atoi(bst); bst.Detach();
            if(hours < SCHEDULER_MIN_HOURS){
                msg.LoadString(IDS_SCHEDULER_MIN_VALUE_IS);
                msg+=" "; msg += SCHEDULER_MIN_HOURS_WIDE;
                MessageBox(msg);
                return false;
            };

            if(hours > SCHEDULER_MAX_HOURS){
                msg.LoadString(IDS_SCHEDULER_MAX_VALUE_IS);
                msg+=" "; msg += SCHEDULER_MAX_HOURS_WIDE;
                MessageBox(msg);
                return false;
            };

            if(hours == 24)
                minutes = SCHEDULER_MAX_MINUTES;
            else
                minutes = hours * 60;
        };

        // save scheduler settings
        if(setScheduler(true, minutes) != 0){
            msg.LoadString(IDS_SCHEDULER_CANNOT_SCHEDULE);
            MessageBox(msg);
        }
    } // end scheduler
  } // end if(saveScheduler)
  saveScheduler = false;

    if(saveSyncTypeContacts){
        if(checkContacts.GetCheck() == BST_UNCHECKED)
            getConfig()->getSyncSourceConfig(CONTACT_)->setSync(syncModeName(SYNC_NONE));
        else {
            if (!strcmp(getConfig()->getSyncSourceConfig(CONTACT_)->getSync(), SYNCTYPE_NONE)) {
                // "two-way" only if it was "none" (otherwise keep current syncmode)
                getConfig()->getSyncSourceConfig(CONTACT_)->setSync(syncModeName(SYNC_TWO_WAY));
            }
        }
    };

    if(saveSyncTypeCalendar){
        if(checkCalendar.GetCheck() == BST_UNCHECKED)
            getConfig()->getSyncSourceConfig(APPOINTMENT_)->setSync(syncModeName(SYNC_NONE));
        else {
            if (!strcmp(getConfig()->getSyncSourceConfig(APPOINTMENT_)->getSync(), SYNCTYPE_NONE)) {
                // "two-way" only if it was "none" (otherwise keep current syncmode)
                getConfig()->getSyncSourceConfig(APPOINTMENT_)->setSync(syncModeName(SYNC_TWO_WAY));
            }
        }
    }

    if(saveSyncTypeTasks){
        if(checkTasks.GetCheck() == BST_UNCHECKED)
            getConfig()->getSyncSourceConfig(TASK_)->setSync(syncModeName(SYNC_NONE));
        else {
            if (!strcmp(getConfig()->getSyncSourceConfig(TASK_)->getSync(), SYNCTYPE_NONE)) {
                // "two-way" only if it was "none" (otherwise keep current syncmode)
                getConfig()->getSyncSourceConfig(TASK_)->setSync(syncModeName(SYNC_TWO_WAY));
            }
        }
    };

    if(saveSyncTypeNotes){
        if(checkNotes.GetCheck() == BST_UNCHECKED)
            getConfig()->getSyncSourceConfig(NOTE_)->setSync(syncModeName(SYNC_NONE));
        else {
            if (!strcmp(getConfig()->getSyncSourceConfig(NOTE_)->getSync(), SYNCTYPE_NONE)) {
                // "two-way" only if it was "none" (otherwise keep current syncmode)
                getConfig()->getSyncSourceConfig(NOTE_)->setSync(syncModeName(SYNC_TWO_WAY));
            }
        }
    };

    // save encryption, global property
    if(checkEncryption.GetCheck()){
        getConfig()->getSyncSourceConfig(CONTACT_)->setEncryption("des");
        getConfig()->getSyncSourceConfig(APPOINTMENT_)->setEncryption("des");
        getConfig()->getSyncSourceConfig(TASK_)->setEncryption("des");
        getConfig()->getSyncSourceConfig(NOTE_)->setEncryption("des");

        // When encryption is used, encoding is always 'base64'.
        getConfig()->getSyncSourceConfig(CONTACT_)->setEncoding("b64");
        getConfig()->getSyncSourceConfig(APPOINTMENT_)->setEncoding("b64");
        getConfig()->getSyncSourceConfig(TASK_)->setEncoding("b64");
        getConfig()->getSyncSourceConfig(NOTE_)->setEncoding("b64");
    }
    else{
        getConfig()->getSyncSourceConfig(CONTACT_)->setEncryption("");
        getConfig()->getSyncSourceConfig(APPOINTMENT_)->setEncryption("");
        getConfig()->getSyncSourceConfig(TASK_)->setEncryption("");
        getConfig()->getSyncSourceConfig(NOTE_)->setEncryption("");

        // Ensure that encoding is the correct one ("b64" only for SIF).
        if ( !strcmp(getConfig()->getSyncSourceConfig(CONTACT_)->getType(), "text/x-vcard") ) {
            getConfig()->getSyncSourceConfig(CONTACT_)->setEncoding("bin");
        }
        if ( !strcmp(getConfig()->getSyncSourceConfig(APPOINTMENT_)->getType(), "text/x-vcalendar") ) {
            getConfig()->getSyncSourceConfig(APPOINTMENT_)->setEncoding("bin");
        }
    }

    if(saveToDisk)
        getConfig()->save();

    return true;
}

void CSyncSettings::OnNcPaint(){
    CFormView::OnNcPaint();
    CScrollView::SetScrollSizes(MM_TEXT, CSize(0,0));   
}

void CSyncSettings::OnBnClickedSchedulerCheckEnabled()
{
    if(checkEnabled.GetCheck() == BST_UNCHECKED){
        lstValue.EnableWindow(FALSE);
        spinValue.EnableWindow(FALSE);
        comboValueType.EnableWindow(FALSE);
    }
    else{
        lstValue.EnableWindow(TRUE);
        spinValue.EnableWindow(TRUE);
        comboValueType.EnableWindow(TRUE);

        CString s1;
        GetDlgItemText(IDC_SCHEDULER_VALUE, s1);
        if(s1==""){
            s1 += SCHEDULER_DEFAULT_MINUTES_WIDE;
            SetDlgItemText(IDC_SCHEDULER_VALUE, s1);
        }
    }

    saveScheduler = true;
}



void CSyncSettings::OnCbnSelchangeSchedulerComboValueType()
{
    if(comboValueType.GetCurSel() == 0)
        spinValue.SetRange(SCHEDULER_MIN_MINUTES , SCHEDULER_MAX_MINUTES);
    if(comboValueType.GetCurSel() == 1)
        spinValue.SetRange(SCHEDULER_MIN_HOURS , SCHEDULER_MAX_HOURS);

    spinValue.UpdateWindow();
    
    saveScheduler = true;
}

void CSyncSettings::OnEnChangeSchedulerValue()
{
    saveScheduler = true;
}

BOOL CSyncSettings::PreTranslateMessage(MSG* pMsg){
    bool bProcessed =false;
    if(pMsg->message == WM_KEYDOWN){
        if(pMsg->wParam == VK_ESCAPE){
            OnBnClickedSyncCancel();
            bProcessed = true;
        }
    };

    if(bProcessed)
        return TRUE;
    else
        return CFormView::PreTranslateMessage(pMsg);
}