 /*
 * Copyright (C) 2006-2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
*/


#include "event/OutlookSyncItemListener.h"
#include "base/Log.h"

#include "HwndFunctions.h"
#include "utils.h"
/* wParam = -1 -> sending items
   wParam = 1  -> receiving items */
void OutlookSyncItemListener::itemAddedByServer(SyncItemEvent &event) {
    SendMessage(HwndFunctions::getWindowHandle(), ID_MYMSG_SYNC_ITEM_SYNCED, (WPARAM) 1 , (LPARAM) syncSourceNameToIndex(event.getSourceName()));
}

void OutlookSyncItemListener::itemDeletedByServer(SyncItemEvent &event) {
    SendMessage(HwndFunctions::getWindowHandle(), ID_MYMSG_SYNC_ITEM_SYNCED, (WPARAM) 1, (LPARAM) syncSourceNameToIndex(event.getSourceName()));
}

void OutlookSyncItemListener::itemUpdatedByServer(SyncItemEvent &event) {
    SendMessage(HwndFunctions::getWindowHandle(), ID_MYMSG_SYNC_ITEM_SYNCED, (WPARAM) 1, (LPARAM) syncSourceNameToIndex(event.getSourceName()));
}

void OutlookSyncItemListener::itemAddedByClient(SyncItemEvent &event) {
    SendMessage(HwndFunctions::getWindowHandle(), ID_MYMSG_SYNC_ITEM_SYNCED, (WPARAM) -1, (LPARAM) syncSourceNameToIndex(event.getSourceName()));
}

void OutlookSyncItemListener::itemUpdatedByClient(SyncItemEvent &event) {
    SendMessage(HwndFunctions::getWindowHandle(), ID_MYMSG_SYNC_ITEM_SYNCED, (WPARAM) -1, (LPARAM) syncSourceNameToIndex(event.getSourceName()));
}

void OutlookSyncItemListener::itemDeletedByClient(SyncItemEvent &event) {
    SendMessage(HwndFunctions::getWindowHandle(), ID_MYMSG_SYNC_ITEM_SYNCED, (WPARAM) -1, (LPARAM) syncSourceNameToIndex(event.getSourceName()));
}


