 /*
 * Copyright (C) 2006-2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
*/

#ifndef INCL_SYNC_EXC
#define INCL_SYNC_EXC


#include "base/fscapi.h"
#include "base/errors.h"
#include <string>


/*
 ******************************************************************
 * Class SyncException: defines eexceptions for sync process.
 ******************************************************************
*/
class SyncException {

private:

    // pointer to SyncException instance
    static SyncException* pinstance;


    // The message to display
    char*  errorMsg;
    // The same message in WCHAR
    WCHAR* werrorMsg;

    // The error code
    DWORD errorCode;

protected:

    // Constructor
    SyncException();


public:

    // Method to create the sole instance of SyncException
    static SyncException* getInstance();
    
    // Destructor
    ~SyncException();


    // Set data of exception
    void setExceptionData(const char* msg, DWORD code = NULL);


    // Clear data of exception
    void clear();


    // Methods to get exception informations
    const char*         getErrorMsg();
    const WCHAR*        wgetErrorMsg();
    const std::wstring  wstrgetErrorMsg();
    _declspec(dllexport) DWORD getErrorCode();
};


// ---------- Static functions -----------

//use these functions to throw Client exceptions.
void throwSyncException(const char* msg, DWORD code = NULL);


#endif
