 /*
 * Copyright (C) 2006-2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
*/

#ifndef INCL_CLIENTMAIL
#define INCL_CLIENTMAIL


#include "outlook/defs.h"
#include "outlook/ClientItem.h"

#include <string>



///////////////////////////////////////////////////////////////////
class ClientMail : public ClientItem {

private:

    // Pointer to microsoft outlook objects.
    _MailItemPtr     pMail;

    // Pointer to Redemption safe objects.
    Redemption::ISafeMailItemPtr pSafeMail;


    void createSafeMailInstance();

    bool isSecureProperty (const std::wstring& propertyName);
    bool isComplexProperty(const std::wstring& propertyName);

    const std::wstring getSafeProperty   (const std::wstring& propertyName);
    const std::wstring getComplexProperty(const std::wstring& propertyName);

    int setComplexProperty(const std::wstring& propertyName, const std::wstring& propertyValue);

public:

    // Constructor
    ClientMail();
    ClientMail(const ClientMail& c);
    ClientMail operator=(const ClientMail& c);

    // Destructor
    ~ClientMail();


    // Set a COM pointer to this object: refresh all members.
    void setCOMPtr(_MailItemPtr& ptr, const std::wstring& itemID);
    void setCOMPtr(_MailItemPtr& ptr);

    // Returns a reference to the internal COM pointer.
    _MailItemPtr& getCOMPtr();

    //
    // Client operations on the item.
    //
    int saveItem();
    int deleteItem();
    ClientItem* copyItem();
    //int moveItem(ClientFolder* destFolder);


    //
    // Methods to menage item properties.
    //
    //const std::wstring getFirstProperty();
    //const std::wstring getNextProperty();
    //const std::wstring getPreviousProperty();
    //const std::wstring getLastProperty();

    //int setProperty(const std::wstring& propertyName, const std::wstring& propertyValue);

};

#endif
