 /*
 * Copyright (C) 2006-2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
*/

#ifndef INCL_CLIENTNOTE
#define INCL_CLIENTNOTE


#include "outlook/defs.h"
#include "outlook/ClientItem.h"

#include <string>



///////////////////////////////////////////////////////////////////
class ClientNote : public ClientItem {

private:

    // Pointer to microsoft outlook objects.
    _NoteItemPtr     pNote;

    bool isSecureProperty (const std::wstring& propertyName);
    bool isComplexProperty(const std::wstring& propertyName);

    const std::wstring getSafeProperty   (const std::wstring& propertyName);
    const std::wstring getComplexProperty(const std::wstring& propertyName);

    int setComplexProperty(const std::wstring& propertyName, const std::wstring& propertyValue);

public:

    // Constructor
    ClientNote();
    ClientNote(const ClientNote& c);
    ClientNote operator=(const ClientNote& c);

    // Destructor
    ~ClientNote();


    // Set a COM pointer to this object: refresh all members.
    void setCOMPtr(_NoteItemPtr& ptr, const std::wstring& itemID);
    void setCOMPtr(_NoteItemPtr& ptr);

    // Returns a reference to the internal COM pointer.
    _NoteItemPtr& getCOMPtr();

    //
    // Client operations on the item.
    //
    int saveItem();
    int deleteItem();
    ClientItem* copyItem();
    //int moveItem(ClientFolder* destFolder);

};

#endif
